# GPU Virtualizáció

## Osztályozás

A virtuálizációhoz hasonlóan itt is a használt technológiától függően különböző fajta GPU virtualizációkról beszélhetünk.

 - **GPU passthrough** (kakukktojás): Nem virtualizációs technológia, de a host os lehetővé teszi egy virtuális gépnek a közvetlen PCI bus-on történő kommunikációt a kártyával. Hátránya: egyszerre csak egy VM használhatja, a használat kötött. Kevés veszteség.

 - **távoli API alapú**: A virtuális gépen speciális API könyvtár segítségével kommunikálunk a host-on keresztül a kártyával. Az API könyvtár egy wrapperhez hasonlítható, a rendes GPU hívásokat a wapper továbbítja a host-ra és az ottani API (CUDA, OpenCL, OpenGL) adja meg az eredményt.
 Mivel a módszer megkerüli a hypervisor réteget, ezért elenyésző többletköltséggel jár. A támogatott API-k rögzítettek, más API használata esetén a host-ot is újra kell konfigurálni. Példák: GVirtuS (CUDA), DS-CUDA (CUDA)

![távoli API](img/remoteAPI.png)

 - **Para- vagy teljes virtualizáció**: 
 - **hardweres virtualizáció**: 





# Források
 - Cheol-Ho Hong, Ivor Spence, and Dimitrios S. Nikolopoulos. 2017. GPU Virtualization and Scheduling Methods: A Comprehensive Survey. ACM Comput. Surv. 50, 3, Article 35 (May 2018), 37 pages. https://doi.org/10.1145/3068281